function varargout = MainUI(varargin)
% MAINUI M-file for MainUI.fig
%      MAINUI, by itself, creates a new MAINUI or raises the existing
%      singleton*.
%
%      H = MAINUI returns the handle to a new MAINUI or the handle to
%      the existing singleton*.
%
%      MAINUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MAINUI.M with the given input arguments.
%
%      MAINUI('Property','Value',...) creates a new MAINUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before MainUI_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to MainUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help MainUI

% Last Modified by GUIDE v2.5 16-Feb-2011 00:33:45

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @MainUI_OpeningFcn, ...
                   'gui_OutputFcn',  @MainUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before MainUI is made visible.
function MainUI_OpeningFcn(hObject, eventdata, handles, varargin)
    % This function has no output args, see OutputFcn.
    % hObject    handle to figure
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    % varargin   command line arguments to MainUI (see VARARGIN)

    % Choose default command line output for MainUI
    global Camera_AdaptorName;
    global Camera_DeviceID;
    global Camera_Format;
    global Camera_Exposure;
    global Camera_ExposureLevel;
    handles.output = hObject;

    % Create video object
    %   Putting the object into manual trigger mode and then
    %   starting the object will make GETSNAPSHOT return faster
    %   since the connection to the camera will already have
    %   been established.
    handles.video = videoinput(Camera_AdaptorName, Camera_DeviceID, Camera_Format);
    handles.video.ReturnedColorspace = 'rgb';
    src = getselectedsource(handles.video);
    handles.video.FramesPerTrigger = 1;
    %src.WhiteBalanceMode = 'manual';
    %src.Brightness = 10;
    %src.Contrast = 15;
    %src.Saturation = 4;
    if (Camera_Exposure == true)
        src.ExposureMode = 'manual';
        src.Exposure = Camera_ExposureLevel;
    end
    
    vidRes = get(handles.video, 'VideoResolution');
    nBands = get(handles.video, 'NumberOfBands');
    handles.hImage = image( zeros(vidRes(2), vidRes(1), nBands) );
    % Update handles structure
    guidata(hObject, handles);

    % UIWAIT makes MainUI wait for user response (see UIRESUME)
    uiwait(handles.MainUI);


% --- Outputs from this function are returned to the command line.
function varargout = MainUI_OutputFcn(hObject, eventdata, handles)
    % varargout  cell array for returning output args (see VARARGOUT);
    % hObject    handle to figure
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)

    % Get default command line output from handles structure
    handles.output = hObject;
    varargout{1} = handles.output;


% --- Executes on button press in startStopCamera.
function startStopCamera_Callback(hObject, eventdata, handles)
    % hObject    handle to startStopCamera (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)

    % Start/Stop Camera
    if strcmp(get(handles.startStopCamera,'String'),'Start Camera')
        % Camera is off.  Change button string and start camera.
        set(handles.startStopCamera,'String','Stop Camera');
        preview(handles.video, handles.hImage);
    else
        % Camera is on.  Stop camera and change button string.
        set(handles.startStopCamera,'String','Start Camera');
        if (isappdata(handles.hImage,'UpdatePreviewWindowFcn'))
            rmappdata(handles.hImage,'UpdatePreviewWindowFcn');
            set(handles.startTracking,'String','Start Tracking');
        end
        stoppreview(handles.video);
    end


% --- Executes on button press in startTracking.
function startTracking_Callback(hObject, eventdata, handles)
    % hObject    handle to startTracking (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    setappdata(handles.hImage,'UpdatePreviewWindowFcn',@ProcessImage);
    % Start/Stop Tracking
    if strcmp(get(handles.startTracking,'String'),'Start Tracking')
        % Camera is off.  Change button string and start camera.
        global notepad;
        notepad = actxserver('WScript.Shell');
        notepad.Run('notepad'); %Invokes notepad.exe
        pause(3); %Waits for the application to load.
        notepad.AppActivate('Notepad'); %Brings notepad to focus
        set(handles.startTracking,'String','Stop Tracking');
    else
        % Camera is on.  Stop camera and change button string.
        set(handles.startTracking,'String','Start Tracking');
        rmappdata(handles.hImage,'UpdatePreviewWindowFcn');
    end



function taucd_Callback(hObject, eventdata, handles)
% hObject    handle to taucd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of taucd as text
%        str2double(get(hObject,'String')) returns contents of taucd as a double

% --- Executes during object creation, after setting all properties.
function taucd_CreateFcn(hObject, eventdata, handles)
% hObject    handle to taucd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function talow_Callback(hObject, eventdata, handles)
% hObject    handle to talow (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of talow as text
%        str2double(get(hObject,'String')) returns contents of talow as a double


% --- Executes during object creation, after setting all properties.
function talow_CreateFcn(hObject, eventdata, handles)
% hObject    handle to talow (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ta1_Callback(hObject, eventdata, handles)
% hObject    handle to ta1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ta1 as text
%        str2double(get(hObject,'String')) returns contents of ta1 as a double


% --- Executes during object creation, after setting all properties.
function ta1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ta1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ta2_Callback(hObject, eventdata, handles)
% hObject    handle to ta2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ta2 as text
%        str2double(get(hObject,'String')) returns contents of ta2 as a double


% --- Executes during object creation, after setting all properties.
function ta2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ta2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in update.
function update_Callback(hObject, eventdata, handles)
% hObject    handle to update (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global TCD;
global TALO;
global TA1;
global TA2;
global K;
global angle;
global higherHysteresisThreshold;
global lowerHysteresisThreshold;
TCD = str2num(get(handles.taucd,'String'));
TALO = str2num(get(handles.talow,'String'));
TA1 = str2num(get(handles.ta1,'String'));
TA2 = str2num(get(handles.ta2,'String'));
K = str2num(get(handles.k,'String'));
angle = str2num(get(handles.angle,'String'));
higherHysteresisThreshold = str2double(get(handles.hh,'String'));
lowerHysteresisThreshold = str2double(get(handles.lh,'String'));


function k_Callback(hObject, eventdata, handles)
% hObject    handle to k (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of k as text
%        str2double(get(hObject,'String')) returns contents of k as a double


% --- Executes during object creation, after setting all properties.
function k_CreateFcn(hObject, eventdata, handles)
% hObject    handle to k (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function angle_Callback(hObject, eventdata, handles)
% hObject    handle to angle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of angle as text
%        str2double(get(hObject,'String')) returns contents of angle as a double


% --- Executes during object creation, after setting all properties.
function angle_CreateFcn(hObject, eventdata, handles)
% hObject    handle to angle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function lh_Callback(hObject, eventdata, handles)
% hObject    handle to lh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of lh as text
%        str2double(get(hObject,'String')) returns contents of lh as a double


% --- Executes during object creation, after setting all properties.
function lh_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function hh_Callback(hObject, eventdata, handles)
% hObject    handle to hh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of hh as text
%        str2double(get(hObject,'String')) returns contents of hh as a double


% --- Executes during object creation, after setting all properties.
function hh_CreateFcn(hObject, eventdata, handles)
% hObject    handle to hh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
