function CD = colorDistortion(image, E, S, alpha)
% Calculates the color distortion values of each pixel in an image.
% Stores the result in a matrix of scalar values.

% Set 0 to 1 as a minimum standard deviation to avoid divide by 0
tempS = S + (S == 0);

operandR = ((image(:,:,1) - (alpha .* E(:,:,1))) ./ tempS(:,:,1)) .^ 2;
operandG = ((image(:,:,2) - (alpha .* E(:,:,2))) ./ tempS(:,:,2)) .^ 2;
operandB = ((image(:,:,3) - (alpha .* E(:,:,3))) ./ tempS(:,:,3)) .^ 2;

CD = (operandR .* operandG .* operandB) .^ 2;